Crypt_DES

# Class: Crypt_DES

Source Location: /lib/3rdParty/phpseclib/Crypt/DES.php

### Class Overview

Pure-PHP implementation of DES.

#### Author(s):

- Jim Wigginton <terrafrost@php.net>

#### Version:

- 0.1.0

### Methods

- Crypt_DES
- decrypt
- disableContinuousBuffer
- disablePadding
- enableContinuousBuffer
- enablePadding
- encrypt
- setIV
- setKey
- _generate_xor

### Class Details

[line 124]
Pure-PHP implementation of DES.

#### Tags:

author: | Jim Wigginton <terrafrost@php.net>
version: | 0.1.0
access: | public

[ Top ]

### Class Methods

### constructor Crypt_DES [line 232]

`Crypt_DES Crypt_DES( [optional $mode = CRYPT_MODE_DES_CBC])`

Default Constructor.

Determines whether or not the mcrypt extension should be used. $mode should only, at present, be CRYPT_DES_MODE_ECB or CRYPT_DES_MODE_CBC. If not explictly set, CRYPT_DES_MODE_CBC will be used.

#### Tags:

access: | public

#### Parameters:

optional | $mode | Integer $mode

[ Top ]

### method decrypt [line 437]

`void decrypt( String $ciphertext)`

Decrypts a message.

If strlen($ciphertext) is not a multiple of 8, null bytes will be added to the end of the string until it is.

#### Tags:

see: | Crypt_DES::encrypt()
access: | public

#### Parameters:

String | $ciphertext |

[ Top ]

### method disableContinuousBuffer [line 550]

`void disableContinuousBuffer( )`

Treat consecutive packets as if they are a discontinuous buffer.

The default behavior.

#### Tags:

see: | Crypt_DES::enableContinuousBuffer()
access: | public

[ Top ]

### method disablePadding [line 582]

`void disablePadding( )`

Do not pad packets.

#### Tags:

see: | Crypt_DES::enablePadding()
access: | public

[ Top ]

### method enableContinuousBuffer [line 537]

`void enableContinuousBuffer( )`

Treat consecutive "packets" as if they are a continuous buffer.

Say you have a 16-byte plaintext $plaintext. Using the default behavior, the two following code snippets will yield different outputs:

1. echo $des-> encrypt ( substr ($plaintext, 0, 8));
2. echo $des-> encrypt ( substr ($plaintext, 8, 8));

1. echo $des-> encrypt ($plaintext);

The solution is to enable the continuous buffer. Although this will resolve the above discrepancy, it creates another, as demonstrated with the following:

1. $des-> encrypt ( substr ($plaintext, 0, 8));
2. echo $des-> decrypt ($des-> encrypt ( substr ($plaintext, 8, 8)));

1. echo $des-> decrypt ($des-> encrypt ( substr ($plaintext, 8, 8)));

With the continuous buffer disabled, these would yield the same output. With it enabled, they yield different outputs. The reason is due to the fact that the initialization vector's change after every encryption / decryption round when the continuous buffer is enabled. When it's disabled, they remain constant.

Put another way, when the continuous buffer is enabled, the state of the Crypt_DES() object changes after each encryption / decryption round, whereas otherwise, it'd remain constant. For this reason, it's recommended that continuous buffers not be used. They do offer better security and are, in fact, sometimes required (SSH uses them), however, they are also less intuitive and more likely to cause you problems.

#### Tags:

see: | Crypt_DES::disableContinuousBuffer()
access: | public

[ Top ]

### method enablePadding [line 571]

`void enablePadding( )`

Pad "packets".

DES works by encrypting eight bytes at a time. If you ever need to encrypt or decrypt something that's not a multiple of eight, it becomes necessary to pad the input so that it's length is a multiple of eight.

Padding is enabled by default. Sometimes, however, it is undesirable to pad strings. Such is the case in SSH1, where "packets" are padded with random bytes before being encrypted. Unpad these packets and you risk stripping away characters that shouldn't be stripped away. (SSH knows how many bytes are added because the length is transmitted separately)

#### Tags:

see: | Crypt_DES::disablePadding()
access: | public

[ Top ]

### method encrypt [line 366]

`void encrypt( String $plaintext)`

Encrypts a message.

$plaintext will be padded with up to 8 additional bytes. Other DES implementations may or may not pad in the same manner. Other common approaches to padding and the reasons why it's necessary are discussed in the following URL:

http://www.di-mgt.com.au/cryptopad.html

An alternative to padding is to, separately, send the length of the file. This is what SSH, in fact, does. strlen($plaintext) will still need to be a multiple of 8, however, arbitrary values can be added to make it that length.

#### Tags:

see: | Crypt_DES::decrypt()
access: | public

#### Parameters:

String | $plaintext |

[ Top ]

### method setIV [line 305]

`void setIV( String $iv)`

Sets the initialization vector. (optional)

SetIV is not required when CRYPT_DES_MODE_ECB is being used. If not explictly set, it'll be assumed to be all zero's.

#### Tags:

access: | public

#### Parameters:

String | $iv |

[ Top ]

### method setKey [line 290]

`void setKey( String $key)`

Sets the key.

Keys can be of any length. DES, itself, uses 64-bit keys (eg. strlen($key) == 8), however, we only use the first eight, if $key has more then eight characters in it, and pad $key with the null byte if it is less then eight characters long.

DES also requires that every eighth bit be a parity bit, however, we'll ignore that.

If the key is not explicitly set, it'll be assumed to be all zero's.

#### Tags:

access: | public

#### Parameters:

String | $key |

[ Top ]

### method _generate_xor [line 323]

`void _generate_xor( Integer $length, &$iv, String $iv)`

Generate CTR XOR encryption key

Encrypt the output of this and XOR it against the ciphertext / plaintext to get the plaintext / ciphertext in CTR mode.

#### Tags:

see: | Crypt_DES::decrypt()
see: | Crypt_DES::encrypt()
access: | public

#### Parameters:

Integer | $length |
String | $iv |
| &$iv |

[ Top ]

Documentation generated on Thu, 28 Oct 2010 21:00:11 +0200 by phpDocumentor 1.4.1